%define bzinstallprefix %{_datadir}
%define bzdatadir %{_localstatedir}/lib/bugzilla

Summary: Bug tracking system
URL: http://www.bugzilla.org/
Name: bugzilla
Version: 3.0.3
Group: Applications/Publishing
Release: 4.ru
License: MPL
Source0: %{name}-%{version}.tar.gz
Source1: bugzilla-httpd-conf
Source2: README.fedora.bugzilla
Patch0: bugzilla-rw-paths.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: noarch
Requires: smtpdaemon, webserver, graphviz, patchutils, mod_perl, perl-SOAP-Lite, perl-Email-Simple, perl-Email-MIME-Modifier, perl-Template-Toolkit, perl-MIME-tools, perl-Email-MIME-Attachment-Stripper, perl-Email-Send, perl-Email-Reply, perl-Email-MIME, perl-Email-Address, mysql, perl-DBD-mysql, mysql-server, perl-GD-Graph perl-Template-GD perl-GD-Text-Util perl-GD perl-Chart ImageMagick-perl perl-PatchReader perl-Email-Date-Format

%package doc
Summary: Bugzilla documentation
Group: Documentation

%package contrib
Summary: Bugzilla contributed scripts
Group: Applications/Publishing

%description
Bugzilla is a popular bug tracking system used by multiple open source 
projects.  It requires a database engine installed - either MySQL or 
PostgreSQL.  Without one of these database engines, Bugzilla will not work.

%description doc
Documentation distributed with the Bugzilla bug tracking system

%description contrib
Contributed scripts and functions for Bugzilla

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1

# Filter unwanted Requires:
cat << \EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* |\
  sed -e '/perl(globals.pl)/d;/perl(BugzillaEmail)/d'
EOF

%define __perl_requires %{_builddir}/%{name}-%{version}/%{name}-req
chmod +x %{__perl_requires}

# Deal with changing /usr/local paths here instead of via patches
%{__perl} -pi -e 's|/usr/local/bin/python\b|%{__python}|' contrib/*.py
%{__perl} -pi -e 's|/usr/local/bin/ruby\b|%{_bindir}/ruby|' contrib/*.rb
grep -rl '/usr/lib/sendmail\b' contrib docs \
| xargs %{__perl} -pi -e 's|/usr/lib/sendmail\b|%{_sbindir}/sendmail|'

%build
find . -depth -name CVS -type d -exec rm -rf {} \;
find . -depth -name .cvsignore -type f -exec rm -rf {} \;
# Remove the execute bit from files that don't start with #!
for file in `find -type f -perm /111`; do
  if head -1 $file | egrep -v '^\#!' &>/dev/null; then
    chmod a-x $file
  fi
done
# Ensure shebang shell scripts have executable bit set
for file in `find -type f -perm /664`; do
  if head -1 $file | egrep '^\#!' &>/dev/null; then
    chmod a+x $file
  fi
done


%install
mkdir -p ${RPM_BUILD_ROOT}/%{bzinstallprefix}/bugzilla
cp -pr * ${RPM_BUILD_ROOT}/%{bzinstallprefix}/bugzilla
mkdir -p ${RPM_BUILD_ROOT}/%{_sysconfdir}/cron.daily
cat << EOM > ${RPM_BUILD_ROOT}/%{_sysconfdir}/cron.daily/bugzilla
#!/bin/bash
# Daily Bugzilla collectstats cron job run
cd %{bzinstallprefix}/bugzilla
./collectstats.pl
EOM
mkdir -p ${RPM_BUILD_ROOT}/%{_sysconfdir}/cron.d
echo "0-59/15 * * * * apache cd %{bzinstallprefix}/bugzilla && env LANG=C %{bzinstallprefix}/bugzilla/whine.pl" > ${RPM_BUILD_ROOT}/%{_sysconfdir}/cron.d/bugzilla
rm -f ${RPM_BUILD_ROOT}/%{bzinstallprefix}/bugzilla/{README,QUICKSTART,UPGRADING,UPGRADING-pre-2.8}
mkdir -p ${RPM_BUILD_ROOT}/%{_datadir}/doc/%{name}-%{version}
cp %{SOURCE2} ./README.fedora
mkdir -p ${RPM_BUILD_ROOT}/%{bzdatadir}
mkdir -p ${RPM_BUILD_ROOT}/%{_sysconfdir}/bugzilla
install -m 0644 -D -p %{SOURCE1}  ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d/bugzilla.conf

%clean
rm -rf ${RPM_BUILD_ROOT}

%post
pushd %{bzinstallprefix}/bugzilla > /dev/null
./checksetup.pl > /dev/null
popd > /dev/null

%files
%defattr(-,root,root,-)
%dir %{bzinstallprefix}/bugzilla
%{bzinstallprefix}/bugzilla/*.cgi
%{bzinstallprefix}/bugzilla/*.js
%{bzinstallprefix}/bugzilla/*.pl
%{bzinstallprefix}/bugzilla/Bugzilla.pm
%{bzinstallprefix}/bugzilla/bugzilla.dtd
%{bzinstallprefix}/bugzilla/duplicates.xul
%{bzinstallprefix}/bugzilla/robots.txt
%{bzinstallprefix}/bugzilla/Bugzilla
%{bzinstallprefix}/bugzilla/images
%{bzinstallprefix}/bugzilla/js
%{bzinstallprefix}/bugzilla/skins
%{bzinstallprefix}/bugzilla/t
%{bzinstallprefix}/bugzilla/template
%ghost %{bzinstallprefix}/bugzilla/bugzilla-req
%config(noreplace) %{_sysconfdir}/httpd/conf.d/bugzilla.conf
%defattr(0755,root,root,-)
%{_sysconfdir}/cron.daily/*
%defattr(0600,root,root,-)
%{_sysconfdir}/cron.d/*
%defattr(-,root,root,-)
%doc README
%doc QUICKSTART
%doc UPGRADING
%doc UPGRADING-pre-2.8
%doc README.fedora
%dir %{bzdatadir}
%dir %{_sysconfdir}/bugzilla
%files doc
%{bzinstallprefix}/bugzilla/docs

%files contrib
%{bzinstallprefix}/bugzilla/contrib

%changelog
* Thu Jan 31 2008 David Diffenbaugh <davediff@nbcs.rutgers.edu> - 3.0.3-4
- added perl-Email-Date-Format to requires
* Fri Jan 25 2008 David Diffenbaugh <davediff@nbcs.rutgers.edu> - 3.0.3-3
- added additional perl modules to requires
* Wed Jan 23 2008 David Diffenbaugh <davediff@nbcs.rutgers.edu> - 3.0.3-2
- added mysql, mysql-server, and perl-DBD-mysql to requires
* Tue Jan 22 2008 David Diffenbaugh <davediff@nbcs.rutgers.edu> - 3.0.3-1
- First Rutgers Release
